<template>
  <main class="main py-5">
    <b-container>
      <b-row v-if="page && page.body">
        <b-col lg="10" class="mx-auto">
          <app-content :title="page.title" :excerpt="page.excerpt" :description="page.body">
            <div class="mt-3 mt-lg-5 mb-2 mb-md-3">
              <div v-for="(dep, depIndex) in deps" :key="'dep' + depIndex" class="mb-2 mb-md-3">
                <h3 class="depname">
                  {{ dep.name }}
                </h3>
                <b-row>
                  <b-col
                    v-for="(staff, index) in dep.staffs"
                    :key="'dep-' + depIndex + '-staff-'+index"
                    cols="6"
                    md="4"
                    xl="3"
                    class="mb-3 mb-lg-4"
                    :class="[index % 2 === 0 ? 'pr-1 pr-md-2': 'pl-1 pl-md-2']"
                  >
                    <figure class="staff" :class="{'staff-hoverable': staff.body}">
                      <div class="image">
                        <v-lazy-image
                          v-if="staff.avatar"
                          :src-placeholder="staff.avatar | image | imageSize('small')"
                          :src="staff.avatar | image"
                          :alt="staff.name"
                          class="w-100"
                        />
                        <p v-if="staff.body" class="d-none d-lg-block">
                          {{ staff.body }}
                        </p>
                      </div>
                      <figcaption>
                        <h3 v-html="getName(staff.name)" />
                        <h5 class="h6 text-secondary">
                          {{ staff.position }}
                        </h5>
                      </figcaption>
                    </figure>
                  </b-col>
                </b-row>
              </div>
            </div>
          </app-content>
        </b-col>
      </b-row>
    </b-container>
  </main>
</template>

<script>
import { mapGetters } from 'vuex'
import appContent from '~/components/PageContent.vue'
export default {
  name: 'AppAboutPage',
  components: {
    appContent
  },
  async fetch ({ store }) {
    await store.dispatch('page/FETCH_PAGE', {
      slug: 'about'
    })
  },
  data () {
    return {
      deps: []
    }
  },
  computed: {
    ...mapGetters({
      page: 'page/getPage'
    })
  },
  mounted () {
    this.getStaffs()
  },
  methods: {
    async getStaffs () {
      const { data } = await this.$axios.$get('staffs')
      this.deps = data
    },
    getName (str) {
      const [name, surname] = str.split(' ')
      if (surname) {
        return name + '<span class="font-weight-bold"> ' + surname + '</span>'
      } else {
        return name
      }
    }
  },
  head () {
    const title = this.page.title
    const description = this.page.meta.description
    const keywords = this.page.meta.keywords
    const image = this.$options.filters.image(this.page.cover)
    return {
      title,
      meta: [
        {
          hid: 'description',
          name: 'description',
          content: description
        },
        {
          hid: 'og:title',
          property: 'og:title',
          content: title
        },
        {
          hid: 'og:description',
          property: 'og:description',
          content: description
        },
        {
          hid: 'keywords',
          name: 'keywords',
          content: keywords
        },
        {
          hid: 'og:image',
          property: 'og:image',
          content: image
        },
        {
          hid: 'og:image:width',
          property: 'og:image:width',
          content: '1000'
        },
        {
          hid: 'og:image:height',
          property: 'og:image:height',
          content: null
        }
      ]
    }
  }
}
</script>

<style lang="scss" scoped>
  //noinspection CssUnknownTarget
  @import "@/assets/scss/_variables.scss";
  @import "~bootstrap/scss/mixins/breakpoints";

  figure.staff {
    position: relative;
    overflow: hidden;
    width: 100%;
    height: 100%;
    color: $dark;
    text-align: center;
    box-shadow: 0 0 5px rgba(0, 0, 0, 0.15);
    background-color: $primary;

    * {
      -webkit-box-sizing: border-box;
      box-sizing: border-box;
      -webkit-transition: all 0.35s ease;
      transition: all 0.35s ease;
    }

    img {
      max-width: 100%;
      vertical-align: top;
    }

    .image {
      position: relative;
      border-bottom: 4px solid $primary;
      z-index: 1;

      &:before {
        width: 0;
        height: 0;
        border-style: solid;
        border-width: 20px 20px 0 20px;
        border-color: $primary transparent transparent transparent;
        content: '';
        position: absolute;
        top: 100%;
        left: 50%;
        -webkit-transform: translate(-50%, -15px);
        transform: translate(-50%, -15px);
        z-index: -1;
        -webkit-transition: all 0.35s ease;
        transition: all 0.35s ease;
        @include media-breakpoint-down(md) {
          border-width: 10px 10px 0 10px;
        }
      }

      p {
        font-weight: 500;
        margin: 0;
        padding: 0 30px;
        line-height: 1.6em;
        position: absolute;
        top: 50%;
        width: 100%;
        color: #ffffff;
        -webkit-transform: translateY(-50%);
        transform: translateY(-50%);
        opacity: 0;
        font-style: italic;
      }
    }

    figcaption {
      background-color: #ffffff;
      padding: 1rem;
      height: 100%;
      @include media-breakpoint-down(md) {
        padding: 1rem 0.5rem 0.5rem;
      }
    }

    h3 {
      margin: 0 0 5px;
      text-transform: capitalize;
      @include media-breakpoint-down(md) {
        font-size: $font-size-base;
      }
    }

    h5 {
      margin: 0;
      @include media-breakpoint-down(md) {
        font-size: $font-size-sm;
      }
    }
  }

  .staff-hoverable {
    &:hover .image:before, &.hover .image:before {
      border-color: $primary transparent transparent transparent;
      -webkit-transform: translate(-50%, 0px);
      transform: translate(-50%, 0px);
    }

    &:hover .image p, &.hover .image p {
      opacity: 1;
    }

    &:hover img, &.hover img {
      opacity: 0;
      -webkit-filter: grayscale(100%);
      filter: grayscale(100%);
    }
  }
  .depname {
    color: black;
    margin-bottom: 2rem;
    @include media-breakpoint-down(sm) {
      font-size: $font-size-lg;
      margin-bottom: 1rem;
    }
  }
</style>
